//
//  Main.c
//
// Copyright(c) 2001 Blodgett Combi
//
// Author: Scott Douglas
// Used by kind permission by PICuWEB http://www.workingtex.com/htpic
// Date: 26 Sep 00
// Build Version: .1
//
//  Compiler Hi-Tech C V7.86
//
//
// Program notes:
//  ----------------------------------------------------------------------
// 1. First pass using PIC development board.
//
// Revision History
//  ----------------------------------------------------------------------
// .1 - Switch from C2C to Hi-Tech compiler       9 January 2001
//
//
#include  <pic1687x.h>
#include "delay.h"
#include "delay.c"
#include "global.h"	 // Global header
#include "spi.h"	       // SPI bus stuff
#include "spi.c"

#ifdef DEBUG_Print
    #include <stdio.h>
    #include <stdlib.h>
    #include "serial.c"
#endif
//
//================== Pic Notes ===================================
//
//  See PIC16F87x Midrange doucument. I did!
//
//=================== MAIN =======================================
//

void main(void)
{
	Power_Up(); // Main power up routine
	// clrwdt();                  // Kick the dog
	while (Error == 0)
	{
		// TMRO interrupted
		if (T0IF)
		{
			T0IF = 0;         // Reset TMRO interrupt
			Ticks++;          // approx 1ms per tick
			TMR0 = 5;         // Reseed TMRO
		}

		//SPI bus I/O and determine state changes. Heartbeat LED
		if (Ticks >= One_Sec)
		{
			DelayMs(5);
			SPI_IO();		// SPI bus transfer/receive		
			PORTC |= 1;       // Turn on lamp heartbeat
			DelayMs(25);
			PORTC = 0;        // Turn it off heartbeat
		}

		// Every five secs do the A/D from the Linear Tech
		if (SPI_Count >= 5)
		{
			Read_SPI_AD();    // Add test later if conversion is complete
			MUX++; 		// Increment the MUX channel select
			if (MUX >= 8)     // Change 8=all chnls, 6 = # of act channels used
			{
				MUX = 0;
				SPI_Count = 0;
			}
		}
	  	#ifdef DEBUG_Print
	       // Add some debugging printf statement here 
	  	#endif
	  	Ticks = 0;
	}

	// clrwdt(); // Kick the dog
}
// Some bad error happened, so process
Handle_Errors();
}
